/*
Copyright 2011 SALVATORE TRENTO <trentosalvatore@libero.it>

This file is part of SNAKE 1.00.

SNAKE 1.00 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SNAKE 1.00  is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SNAKE 1.00.  If not, see
http://www.gnu.org/licenses/>.

*/

#include "Grafica.h"
#include <string>

Grafica :: Grafica ()
{
	Finestra();
}

void Grafica :: Menu()const
{

mvprintw(6,7, "        OOOOO  OOO   O  OOOOOOO  OO   O  OOOOOO   OO  OO     ");
mvprintw(7,7, "        OO     OOOO  O  OO   OO  OO OOO  OO       OO  OO     ");
mvprintw(8,7, "        OOOOO  OO OO O  OOOOOOO  OOOO    OOOOO    OO  OO     ");
mvprintw(9,7, "           OO  OO OOOO  OO   OO  OO OOO  OO		   ");
mvprintw(10,7," OO OO  OOOOO  OO  OOO  OO   OO  OO   O  OOOOOO   OO  OO     ");
mvprintw(13,7,"      By Trento Salvatore -> trentosalvatore@libero.it    ");
mvprintw(15,8,"Premi un tasto...");

refresh();	
getch();

}

void Grafica :: StampaMatrice()const 
{
	for (int i=0; i<snake.GetRiga(); i++)	
		mvprintw(i+1,4,snake.GetRigaMatrice(i));	
	
	//printw("\nPunteggio: "); //INSERIRE ALGORITMO CHE TRASF INT IN CHAR;
}

void Grafica :: Finestra()
{
	int PremiTasto;
	TastoPrec=2; //Per default, il tasto prec è in direzione verso destra;	
	
	initscr(); 	
	keypad(stdscr,TRUE);
	start_color();	
	curs_set(0);
	init_pair(1,COLOR_GREEN, COLOR_BLACK);
	attron(COLOR_PAIR(1));
	
	Menu();
	
	timeout(100);

	do
	{
		StampaMatrice();
		refresh();
		PremiTasto = getch();
		erase();		

		if (PremiTasto == ERR) 
 		{
			bool v=snake.Direzione(TastoPrec);
			if (v==false)
				PremiTasto=27;
			
		}

		else if(PremiTasto != ERR)
		{  	
			PremiTasto= VerTasto(PremiTasto,TastoPrec);	
		
			if (PremiTasto!=27 && PremiTasto!=80 || PremiTasto!=112) 
			{	
				if (PremiTasto!=27 && snake.Direzione(PremiTasto)==false)
					PremiTasto=27;
				
				else if ( PremiTasto!=27 && snake.Direzione(PremiTasto) )
					TastoPrec=PremiTasto;
			
				else 
					PremiTasto=27;	
			}
		}//else if;
	

	}while (PremiTasto != 27);	//27=ESC;
	
	StampaMatrice();
	mvprintw(snake.GetRiga()/2,4+snake.GetColonna()/2-10, "...GAME OVER...");
	refresh();
	timeout(-1);
	getch();
	endwin();
}

int Grafica :: VerTasto( int tasto, int TastoPrec)const
{
	//Tasto Sopra;
	if (tasto==87 || tasto== 119 || tasto==KEY_UP )
	{
		if (TastoPrec==1)
			return TastoPrec;
		return 0;
	}
	
	//Tasto Sotto;
	else if (tasto==83 || tasto == 115 || tasto==KEY_DOWN)
	{
		if (TastoPrec==0)
			return TastoPrec;
		return 1;
	}
	
	//Tasto Destro;
	else if (tasto==68 || tasto == 100 || tasto==KEY_RIGHT)
	{
		if (TastoPrec==3)
			return TastoPrec;
		return 2;
	}
	
	//Tasto Sinistro;
	else if (tasto==65 || tasto == 97 || tasto==KEY_LEFT)
	{
		if (TastoPrec==2)
			return TastoPrec;	
		return 3;
	}

	//Tasto ESC;
	else if (tasto == 27) 
		return 27;
	
	//Tasto (P)ausa;
	else if (tasto == 80 || tasto==112)
	{
		timeout(-1);
		StampaMatrice();
		mvprintw(snake.GetRiga()/2,4+snake.GetColonna()/2-10, "...PAUSE...");
		refresh();
		getch();
		timeout(100);
		return TastoPrec;
	}

	else 
		return TastoPrec;
} 

