/*
Copyright 2011 SALVATORE TRENTO <trentosalvatore@libero.it>

This file is part of SNAKE 1.00.

SNAKE 1.00 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SNAKE 1.00  is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SNAKE 1.00.  If not, see
http://www.gnu.org/licenses/>.

*/


/*
La classe Grafica.h, ha la funzione di manipolare la classe Snake.h
e di modificare, se neccessario, gli elementi che la compongono;

Per lo sviluppo della parte grafica viene utilizzata la libreria <ncurses.h>

*/

#ifndef GRAFICA_H
#define GRAFICA_H

#include <ncurses.h>
#include "Snake.h"

class Grafica
{
	private:
		Snake snake; 
		int TastoPrec;
		void Finestra();
		int VerTasto( int tasto, int TastoPrec)const;
		void Menu()const;		
	
		void StampaMatrice()const;
		void Insegna()const;
		int InputDaTastiera(int);
	
	public:
		Grafica();
		
};
#endif

