/*
Copyright 2011 SALVATORE TRENTO <trentosalvatore@libero.it>

This file is part of SNAKE 1.00.

SNAKE 1.00 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SNAKE 1.00  is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SNAKE 1.00.  If not, see
http://www.gnu.org/licenses/>.

*/

/*
La classe Snake.cpp, viene utilizzare per poter implementare i prototopi inizializza
nella classe Snake.h;
*/


#include "Snake.h"

bool Snake :: PresenzaCibo=false; //False, per il cibo non presente nella matrice;
int  Snake :: Punteggio=0;

Snake :: Snake(int Riga, int Colonna, char corn, char serp, char Cibo)
	:R(Riga),C(Colonna),cornice(corn), serpente(serp), cibo(Cibo)
{	
	M=new char *[R]; 	//Impostazione delle righe
	for (int i=0; i<R; i++) //Inpostazione delle colonne;
		M[i]=new char [C];	

	//Riempimento Matrice;
	for (int i=0; i<R; i++)
		for (int j=0; j<C; j++)
			M[i][j]=' ';

	for (int i=0; i<R; i++)
	{
		M[i][0]=cornice;   //Cornice prima colonna;
		M[i][C-1]=cornice; //Cornice ultima colonna;
	}	
	
	for (int j=0; j<C; j++)
	{
		M[0][j]=cornice;   //Cornice prima riga;
		M[R-1][j]=cornice; //Cornice ultima riga;
	}
	
	//Inserimento del serpende nel centro della matrice;
	int cont=((C/2) - 5);	//5 è la lunghezza del serpente;
		
	//Memorizzazione della posizione del serpente all'interno della lista percorso;
	while (cont!=( C/2) )
	{
		SetPercorso(R/2,cont);
		M[R/2][cont]=serpente;
		cont++;
	}	
}

Snake :: ~Snake()
{
	for (int i=0; i<R; i++)
		delete [] M[i];
	delete [] M;
}

void Snake :: SetRiga(const int valore){ R=valore; }		
void Snake :: SetColonna(const int valore){ C=valore; }	
void Snake :: SetCornice(const char carattere){ cornice=carattere; }
void Snake :: SetSerpente(const char carattere){ serpente=carattere;}

void Snake :: SetPercorso(const int Riga, const int Colonna)
{
	Posizione tmp;
	tmp.SetRiga(Riga);
	tmp.SetColonna(Colonna);	
	
	percorso.push_back(tmp);
}

int  Snake :: GetRiga()const     { return R; }
int  Snake :: GetColonna()const  { return C; }
char Snake :: GetCornice()const  { return cornice; }
char Snake :: GetSerpente()const { return serpente; }		

int Snake :: GetRcorr() const 
{//Restituisce la posizione riga della testa;
	return percorso.back().GetRiga();
}

int Snake :: GetCcorr()const
{//Restituiesce la posizione colonna della testa;
	return percorso.back().GetColonna();
}

char* Snake ::  GetRigaMatrice(const int i)const
{
	return M[i] ;
}

bool Snake :: Direzione (const int Input)
{	
	Tastiera tasto (R,C, cibo);
	Cibo c;
	
	bool V= tasto.SetTasto(M, GetRcorr(), GetCcorr(), 
		percorso, serpente, cornice, Input, PresenzaCibo);

	Punteggio+=tasto.GetPunteggio();

        if (V==false)
		return false;

	else if ( V && PresenzaCibo==false) 
	{	
		//Se il cibo non è presente, aggiungerlo nella Matrice;
		c.GeneraCibo(M,R,C,serpente,cibo,PresenzaCibo);
		return true;	
	}

	else if (V && PresenzaCibo==true)
		return true;
}

int Snake :: GetPunti()const
{
	return Punteggio;
}


