/*
Copyright 2011 SALVATORE TRENTO <trentosalvatore@libero.it>

This file is part of SNAKE 1.00.

SNAKE 1.00 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SNAKE 1.00  is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SNAKE 1.00.  If not, see
http://www.gnu.org/licenses/>.

*/

/*
La classe Snake.h, è la base dello sviluppo del gioco;

Tale classe ha la funzione di:

	1)Impostare i dati necessari per lo sviluppo del piano di gioco,
		tali dati sono, Numero di righe e colonne, carattere cornice,
		carattere del serpente, e carattere del cibo;

	2)Sono presenti le funzioni set e get, per relative modifiche e 
		lettura dei dati;

	3)Dalla Funzione Derizione, vengono utilizzate altre librerie 
		per la manipolazione dei dati della classe Snake.h,
		per poter essere modificate in base ai tasti premuti;	

*/

#ifndef SNAKE_H
#define SNAKE_H

#include <iostream>
#include <list>		//Per memorizzare le posizioni occupate dal serpente;
#include "Posizione.h"	//Memorizza Riga e Colonna per creare una lista di posizioni;
#include "Tastiera.h"	//Verifica se il tasto premuto può essere accettato o meno;
#include "Cibo.h"	//Inserisce il cibo, i modo casuale, nella matrice;

using namespace std;

class Snake
{
	private:
		char **M;
		int R,C;			
		char cornice,serpente,cibo; 	
		static bool PresenzaCibo;
		static int Punteggio;

		list <Posizione> percorso; 

	public:		
		Snake(int Riga=20, int Colonna=70, char corn='*', 
		      char serp='o', char Cibo=36);
		~Snake();

//---------------------------Funzioni Set--------------------------------------
		void SetRiga(const int valore);		//Imposta numero righe;
		void SetColonna(const int valore);	//Imposta numero colonne;
		void SetCornice(const char carattere);	//Imposta carattere cornice;
		void SetSerpente(const char carattere);	//Imposta carattere serpente;
		
		//Funzione per memorizzare le postazioni occupate dal serpente;		
		void SetPercorso(const int Riga, const int Colonna);	

//---------------------------Funzioni Get--------------------------------------	
		int  GetRiga()const;		//Restituisce numero delle riga;
		int  GetColonna()const;		//Restituisce numero delle colonna;
		char GetCornice()const;		//Restituisce carattere cornice;	
		char GetSerpente()const;	//Restituisce carattere serpente;
		int  GetRcorr()const;		//Restituisce Riga della testa;
		int  GetCcorr()const;		//Restituisce Colonna della testa;
		char* GetRigaMatrice(const int i)const;

		//Funzione per Verificare se il tasto premuto sia possibile;
		bool Direzione (const int tasto);
		int GetPunti()const;
};	
#endif





