/*
Copyright 2011 SALVATORE TRENTO <trentosalvatore@libero.it>

This file is part of SNAKE 1.00.

SNAKE 1.00 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SNAKE 1.00  is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SNAKE 1.00.  If not, see
http://www.gnu.org/licenses/>.

*/


#include "Tastiera.h"

int Tastiera :: Punteggio=0;

Tastiera :: Tastiera(const int R, const int C, char Cibo)
	 :Righe(R), Colonne(C), cibo(Cibo)
{	
}

bool Tastiera :: SetTasto(char **M, const int R, const int C, list<Posizione> & percorso, 
	 		  const char omino, const char cornice, const int Input, bool & Presenza)	
{
	bool v;	
	
	switch(Input)	
	{
		case 0 : v = TastoSopra   (M, R, C, percorso, cornice, omino, Presenza);break;
		case 1 : v = TastoSotto   (M, R, C, percorso, cornice, omino, Presenza);break;
		case 2 : v = TastoDestro  (M, R, C, percorso, cornice, omino, Presenza);break;
		case 3 : v = TastoSinistro(M, R, C, percorso, cornice, omino, Presenza);break;
		default : cout<<"Errore in Tastiera.cpp"<<endl;
	}	
	return v;
}

bool Tastiera :: TastoSopra(char **M, const int R, const int C,list<Posizione> & percorso, 
			    const char cornice, const char omino, bool & Presenza)
{
	if (M[R-1][C] != omino  ) 
	{
		SpostaSopra(M,R,C, percorso, cornice, omino, Presenza);
		return true;
	}
	return false;
}

bool Tastiera :: TastoSotto(char **M, const int R, const int C, list<Posizione> & percorso,
			    const char cornice, const char omino, bool & Presenza)
{
	if (M[R+1][C] != omino )
	{	
		SpostaSotto(M,R,C, percorso, cornice, omino, Presenza);
		return true;
	}
	return false;	

}

bool Tastiera :: TastoDestro(char **M, const int R, const int C, list<Posizione> & percorso,
			     const char cornice, const char omino, bool & Presenza)
{
	if (M[R][C+1] != omino )
	{
		SpostaDestro(M,R,C, percorso, cornice, omino, Presenza);
		return true;
	}
	return false;	

}

bool Tastiera :: TastoSinistro(char **M, const int R, const int C, list<Posizione> & percorso,
		const char cornice, const char omino, bool & Presenza)
{
	if (M[R][C-1] != omino )
	{
		SpostaSinistro(M,R,C, percorso, cornice, omino, Presenza);
		return true;
	}
	return false;	
}

void Tastiera :: SpostaSopra (char **M, const int R, const int C,list<Posizione> & percorso,
			      const char cornice, const char omino, bool & Presenza)
{
	if (M[R-1][C] == cornice) //Se la testa del serpente tocca la cornice;
		ModListaMatrice1 (M,Righe-2, C,percorso, omino);

	else if (M[R-1][C] != cornice && M[R-1][C]!=cibo)
		ModListaMatrice1 (M, R-1, C,percorso, omino);
	
	else if (M[R-1][C] == cibo)
	{
		ModListaMatrice2(M, R-1, C,percorso, omino);
		Presenza=false; //Cibo mangiato, quindi non è più presente nella M;	
	}
	
}
	
void Tastiera :: SpostaSotto (char **M, const int R, const int C,list<Posizione> & percorso,
			      const char cornice, const char omino, bool & Presenza)
{
	if (M[R+1][C] == cornice) //Se la testa del serpente tocca la cornice;
		ModListaMatrice1 (M, 1, C,percorso, omino);

	else if (M[R+1][C] != cornice && M[R+1][C]!=cibo)//Se invece non la toccasse;
		ModListaMatrice1 (M, R+1, C,percorso, omino);
	
	else if (M[R+1][C] == cibo)
	{
		ModListaMatrice2(M, R+1, C,percorso, omino);
		Presenza=false;
	}

}
	
void Tastiera :: SpostaDestro (char **M, const int R, const int C,list<Posizione> & percorso,
			       const char cornice, const char omino, bool & Presenza)
{
	if (M[R][C+1] == cornice) //Se la testa del serpente tocca la cornice;
		ModListaMatrice1 (M, R, 1,percorso, omino);

	else if (M[R][C+1] != cornice && M[R][C+1]!=cibo)//Se invece non la toccasse;
		ModListaMatrice1 (M, R, C+1,percorso, omino);
	
	else if (M[R][C+1] == cibo)
	{
		ModListaMatrice2(M, R, C+1,percorso, omino);
		Presenza=false;
	}
}
	
void Tastiera :: SpostaSinistro (char **M, const int R, const int C,list<Posizione> & percorso,
				const char cornice, const char omino, bool & Presenza)
{
	if (M[R][C-1] == cornice) //Se la testa del serpente tocca la cornice;
		ModListaMatrice1 (M, R, Colonne-2,percorso, omino);

	else if (M[R][C-1] != cornice && M[R][C-1]!=cibo)	//Se invece non la toccasse;
		ModListaMatrice1 (M, R, C-1,percorso, omino);
	
	else if (M[R][C-1] == cibo)
	{
		ModListaMatrice2(M, R, C-1,percorso, omino);
		Presenza=false;
	}

}

void Tastiera :: ModListaMatrice1 (char **M, const int r, const int c, 
				list<Posizione> & percorso, const char omino)
{
	list <Posizione> :: iterator it= percorso.begin();

	M[(*it).GetRiga()][(*it).GetColonna()]=' '; 
	percorso.erase(it);	//Cencalla primo elemento della lista percorso;

	M[r][c]=omino;
	
	Posizione tmp;
	tmp.SetRiga(r);
	tmp.SetColonna(c);

	percorso.push_back(tmp);		
		
}

void Tastiera :: ModListaMatrice2 (char **M, const int r, const int c, 
				list<Posizione> & percorso, const char omino)
{
	M[r][c]=omino;	

	Posizione tmp;
	tmp.SetRiga(r);
	tmp.SetColonna(c);

	percorso.push_back(tmp);
	Punteggio+=10;
}

int Tastiera :: GetPunteggio()const
{
	return Punteggio;
}















