/*
Copyright 2011 SALVATORE TRENTO <trentosalvatore@libero.it>

This file is part of SNAKE 1.00.

SNAKE 1.00 is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SNAKE 1.00  is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SNAKE 1.00.  If not, see
http://www.gnu.org/licenses/>.

*/

/*
La classe Tastiera.h, ha il compito di verificare i tasti premuti.

Se i tasti premuti sono accettabili modificare la matrice e la list<Posizione>percorso.

Le modifiche vengo effettuate in base a:
	1)Se il serpente incotra il muro, far si che esca dalla parte opposta;
	2)Se il serpente non incontra nulla davanti, incrementare le posizioni in modo 
		da poter generare uno scorrimento all'interno della matrice;
	3)Se il serpente incontra il cibo, si deve aggiungere una nuova posizione 
		in percorso.push_back(posizione);
		Dopo che il serpente mangia il cibo, modificare il parametro
		boolean (Presenza=false) per indicare che il cibo non è più presente nella
		matrice;
*/


#ifndef TASTIERA_H
#define TASTIERA_H

#include <iostream>
#include <list>
#include "Posizione.h"

using namespace std;

class Tastiera
{
	private:
		int Righe, Colonne;
		char cibo;
		static int Punteggio;
		
	public:
		Tastiera( const int R, const int C, char Cibo); //Costruttore di default;

	bool SetTasto(char **M, const int R, const int C, list<Posizione> & percorso, 
		const char omino, const char cornice, const int Input,
		 bool & Presenza);	
		
	int GetPunteggio()const;

	private:
	bool TastoSopra (char **M, const int R, const int C,
		list<Posizione> & percorso, const char conrnice, 
		const char omino, bool & Presenza);

	bool TastoSotto (char **M, const int R, const int C,
		list<Posizione> & percorso, const char cornice, 
		const char omino, bool & Presenza);

	bool TastoDestro (char **M, const int R, const int C,
		list<Posizione> & percorso, const char conrnice,
		const char omino, bool & Presenza);

	bool TastoSinistro (char **M, const int R, const int C,
		list<Posizione> & percorso, const char cornice, 
		const char omino, bool & Presenza);	

	void SpostaSopra (char **M, const int R, const int C,
		list<Posizione> & percorso, const char cornice,
		const char omino, bool & Presenza);

	void SpostaSotto (char **M, const int R, const int C,
		list<Posizione> & percorso,const char cornice,
		const char omino, bool & Presenza);

	void SpostaDestro (char **M, const int R, const int C,
		list<Posizione> & percorso, const char cornice, 
		const char omino, bool & Presenza);

	void SpostaSinistro (char **M, const int R, const int C,
		list<Posizione> & percorso,const char cornice,
		const char omino, bool & Presenza);
	
	//Se la testa del serpente tocca la cornice;
	void ModListaMatrice1 (char **M, const int r, const int c,
		 list<Posizione> & percorso, const char omino);
	
	//Funzione per lo scorrimento normale;
	void ModListaMatrice2 (char **M, const int r, const int c,
		 list<Posizione> & percorso, const char omino);

	



};
#endif





















